<%@page import="java.util.Collection"%>
<%@page import="java.security.cert.X509Certificate"%>
<%@page import="net.java.dev.sommer.foafssl.verifier.DereferencingFoafSslVerifier"%>
<%@page import="org.pelds.auth.FoafSslInterface"%>

<%@ include file="header.jsp" %>

<%
boolean queryUsesHttps = request.getScheme().toUpperCase().equals("HTTPS");
X509Certificate[] certificates = (X509Certificate[]) request.getAttribute("javax.servlet.request.X509Certificate");
boolean userSentCertificate = (certificates != null && certificates.length > 0);
Collection<String> verifiedIds = FoafSslInterface.getVerifiedWebIds(request); 
boolean userCertVerified = (verifiedIds.size() > 0);
%>

<%
if (!queryUsesHttps) {
%>
	<div class="warn">
		<h2>HTTPS protocol recommended</h2>
		<p>Your client did not use HTTP over SSL!</p>
		<p>A successful authentication via FOAF+SSL is needed for full access. You may <a href="cert-req.jsp">create a certificate</a> for your Web ID and then <a href="foafbuilder.jsp">add it to your FOAF file</a>.</p>
	</div>
<% } 
if (queryUsesHttps && !userSentCertificate) {
%>
	<div class="warn">
		<h2>No Client certificate found</h2>
		<p>Your client did not send a SSL Client certificate!</p>
		<p>A successful authentication via FOAF+SSL is needed for full access. You may <a href="cert-req.jsp">create a certificate</a> for your Web ID and then <a href="foafbuilder.jsp">add it to your FOAF file</a>.</p>
	</div>
<% } 
if (queryUsesHttps && userSentCertificate && !userCertVerified) {
%>
	<div class="warn">
		<h2>FOAF+SSL authentication failure</h2>
		<p>Your client certificate(s) could not be verified!</p>
		<p>A successful authentication via FOAF+SSL is needed for full access. You may <a href="cert-req.jsp">create a certificate</a> for your Web ID and then <a href="foafbuilder.jsp">add it to your FOAF file</a>.</p>
	</div>
<% } %>


<%
if (userCertVerified) {
%>
	<div class="idlist">
	<h2>FOAF+SSL Authenticated Web IDs</h2>
	<ul>
	<% for (String id : verifiedIds) {%>
		<li><a href="<%= id %>" target="_new"><%= id %></a></li>
	<%} %>
	</ul>
	</div>
<% } %>


	<h2>RDF Query</h2>
	<p>Enter your <a href="http://www.w3.org/TR/rdf-sparql-query/">SPARQL</a> query in the textbox below. Be sure to include the FROM statement to specify a dataset.</p>

	<form id="queryForm" action="query" method="get">
		<textarea name="query" cols="70" rows="10"></textarea>
		<br/>
		Preferred Result Format:
		<input type="radio" name="output" value="xml" checked="checked"/> XML
		<input type="radio" name="output" value="json"/> JSON
		<input type="radio" name="output" value="txt"/> Text
		
		<br/>
		<button type="submit">Execute Query</button>
	</form>
	
	<br />
	<h2>RDF Update</h2>
	<p>Use a <a href="http://www.w3.org/Submission/SPARQL-Update/">SPARQL/Update</a> query to create or change a dataset. Be sure to specify a dataset with INTO/FROM statements.</p>
<% if (userCertVerified) { %>

	<form id="updateForm" action="update" method="get">
		<textarea name="query" cols="70" rows="10"></textarea>
		<!-- <br/>
		Dataset:
		<input type="text" name="default-graph-uri" size="50"/> 
		  -->
		<br/>
		<button type="submit">Execute Update</button>
	</form>
	
<% } else { %>
	<div class="warn"><p>Update element disabled due to authentication failure</p></div>
<% } %>
<br />

<h2>Access Rules</h2>
<p>Specify the access policy to your dataset using the PeLDS rule format here.</p>
<% if (userCertVerified) { %>

	<form id="ruleForm" action="rule" method="get">

		<textarea name="rules" cols="70" rows="10"></textarea>
		<br/>
		Dataset:
		<input type="text" name="dataset" size="50"/> 
		
		<br/>
		<button type="submit">Show / Update rules</button>
	</form>
<% } else { %>
	<div class="warn"><p>Rule access disabled due to authentication failure</p></div>

<% } %>
<br />
<%@ include file="footer.jsp" %>	