package org.pelds.servlet;

import javax.servlet.http.HttpServletRequest;

/**
 * Prepares the request parameters for the rule access servlet
 * 
 * @author Hannes Muehleisen (hannes@muehleisen.org)
 * @see RuleRequestServlet
 */
public class RuleRequestParameters {
	// parameters
	protected String datasetUri;
	protected String ruleStr;

	// errors
	protected String errorMsgs;

	/**
	 * @see org.pelds.servlet.RequestParameters#process(javax.servlet.http.HttpServletRequest)
	 */
	public boolean process(HttpServletRequest req) {
		errorMsgs = "";

		// - the SPARQL query
		datasetUri = req.getParameter("dataset");
		if (datasetUri == null || datasetUri.equals("")) {
			errorMsgs += "Dataset not specified. ";
		}

		ruleStr = req.getParameter("rules");
		return (errorMsgs.equals(""));

	}

	public String getErrorMsgs() {
		return errorMsgs;
	}

	public String getDatasetUri() {
		return datasetUri;
	}

	public String getRuleStr() {
		return ruleStr;
	}

	public boolean hasRuleString() {
		return (ruleStr != null && !"".equals(ruleStr));
	}
}