package org.pelds.util;

import java.util.logging.Logger;

/**
 * Simple timer class for internal time measurement
 * 
 * @author Hannes Muehleisen (hannes@muehleisen.org)
 * 
 */
public class Timer {
	static private Logger log = Logger.getLogger("Timer");

	private long start = 0;
	private String name;

	/**
	 * Constructor, creates a timer with the given label
	 * 
	 * @param aName
	 *            timer label
	 */
	public Timer(String aName) {
		name = aName;
	}

	/**
	 * Start the new timer
	 * 
	 * @return current timer instance for call chaining
	 */
	public Timer start() {
		start = System.currentTimeMillis();
		return this;
	}

	/**
	 * Stop the timer
	 * 
	 * @return elapsed time in milliseconds
	 */
	public long stop() {
		long elapsed = System.currentTimeMillis() - start;
		log.info(name + ": " + elapsed + "ms");
		return elapsed;
	}

}
